/* -*- c++ -*- ***************************************************************/
/* Echtzeitsysteme                                                           */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/*        D S R _ E x e c u t o r _ I n t e r r u p t _ S t a c k            */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/* Diese Implementierung fuehrt die DSRs auf dem Interrupt-Stack aus         */
/*****************************************************************************/

#include "devices/derivate.h"
#include "interrupt/dsr_executor_interrupt_stack.h"
#include "interrupt/guard.h"

void execute_dsrs() {
  cpu.to_dsr_stack();
  guard.execute_pending_dsrs_inner();
  cpu.from_dsr_stack();
}

void DSR_Executor_Interrupt_Stack::execute_pending_dsrs() {
  execute_dsrs();
}
