/* -*- c++ -*- ***************************************************************/
/* Echtzeitsysteme                                                           */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/*            G U A R D E D _ M U L T I _ L E V E L _ Q U E U E _            */
/*          S C H E D U L E R _ D E F E R R A B L E _ S E R V E R            */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/* A multi level queue scheduler that is also capable of dealing with        */
/* deferrable servers.                                                       */
/*****************************************************************************/

#ifndef __guarded_multi_level_queue_scheduler_deferrable_server_h__
#define __guarded_multi_level_queue_scheduler_deferrable_server_h__

#include "interrupt/secure.h"
#include "thread/deferrable_server.h"
#include "thread/multi_level_queue_scheduler_deferrable_server.h"
#include "thread/thread.h"

class Guarded_Multi_Level_Queue_Scheduler_Deferrable_Server 
  : protected Multi_Level_Queue_Scheduler_Deferrable_Server< 8 >
{

public:

  void enlist(Deferrable_Server* server);

  void add(Thread* thread);

  void add(Deferrable_Server* server);

  void exit();

  void yield();

  void kill(Thread* thread);

  void kill(Deferrable_Server* server);
};

#endif /* __guarded_multi_level_queue_scheduler_deferrable_server_h__ */
